#!/usr/bin/perl
#Usage:
#count_sequence_map.pl hit_file org_zeroes_hash seq_name_to_org_hash
use Storable;

my $matchfile = $ARGV[0] || "-";
my $genehashfile = $ARGV[1] || "-";
my $gihashfile = $ARGV[2] || "-";

my $hashref = retrieve($genehashfile);
my %gene_count=%$hashref;
my $gihashref = retrieve($gihashfile);
my %gi_hash=%$gihashref;

open FILE, "< $matchfile" or die "Can't open $matchfile : $!";

while(my $line = <FILE> ) {
	chomp($line);
	@values=split('\t',$line);
	
        if (!($values[1] eq ""))
        {
          my $gi = $values[1];
          my $org = $gi;

          if (exists($gi_hash{$gi})){
            $org=$gi_hash{$gi};
          }

          if (exists($gene_count{$org}))
          {
            $gene_count{$org}++;
          }
          else
          {
            $gene_count{$org}=1;
          }
        }
}

close FILE;

for my $key (sort keys %gene_count ) {
	my $value = $gene_count{$key};
	print "$key\t$value\n";
}
